<template>
  <div class="check-btn" :class="{ 'img-error': imgError }" :variant="variant">
    <slot>
      <div class="check-btn__content">
        <slot name="img">
          <div v-if="img" class="check-btn__img">
            <img v-if="!imgError" ref="imgRef" :alt="text" :src="img" />
            <span v-else>{{ $t(text) }}</span>
          </div>
        </slot>
        <span v-if="text" class="check-btn__text">{{ $t(text) }}</span>
      </div>
    </slot>
    <div class="check-btn__check">
      <slot name="check-icon">
        <svg-icon
          svg-name="circle-check-v2"
          class-name="w-full h-full min-h-[0.75rem] min-w-[0.75rem] object-contain"
        />
      </slot>
    </div>
  </div>
</template>

<script setup lang="ts">
const props = defineProps({
  variant: {
    type: String as PropType<"TEXT_ONLY" | "ICON_AND_TEXT" | "IMAGE_ONLY">,
    required: false,
    default: "ICON_AND_TEXT",
  },
  img: {
    type: String,
    default: "",
  },
  text: {
    type: String,
    default: "",
  },
});
const emit = defineEmits(["img-error"]);
const imgError = ref<boolean>(true);
const imgRef = ref<HTMLImageElement | null>(null);
onMounted(() => {
  if (props.img) {
    checkImageExistOnServer(props.img).then((exist) => {
      imgError.value = !exist;
      if (!exist) {
        emit("img-error", imgRef.value);
        imgRef.value?.remove();
      }
    });
  }
});

const checkImageExistOnServer = (url: string): Promise<boolean> => {
  return new Promise((resolve) => {
    const img = new Image();
    img.onload = () => resolve(true);
    img.onerror = () => resolve(false);
    img.src = url;
  });
};
</script>

<style scoped lang="scss">
.check-btn :deep() {
  --height: initial;
  --border-radius: 8px;
  --content-padding: 0.5rem 2.5rem 0.5rem 1rem;
  --bg: transparent;
  --font-size: 14px;
  --border-color: var(--border);
  --text-color: var(--text5);
  --selected-border-color: var(--primary);
  --selected-text-color: var(--selected);
  --check-color: var(--primary);
  border-radius: var(--border-radius);
  position: relative;
  width: 100%;
  height: var(--height);
  max-width: 100%;
  overflow: hidden;
  background: var(--bg);
}

.check-btn[variant="TEXT_ONLY"] {
  --height: 38px;
  --border-radius: 4px;
  --content-padding: 0;
}
.check-btn[variant="TEXT_ONLY"] .check-btn__content {
  justify-content: center;
}
.selected .check-btn[variant="TEXT_ONLY"].left-select .check-btn__content {
  justify-content: left;
}

.check-btn[variant="TEXT_ONLY"].text-left .check-btn__content,
.check-btn.img-error[variant="IMAGE_ONLY"] .check-btn__content {
  justify-content: flex-start;
}
.check-btn[variant="TEXT_ONLY"].text-right .check-btn__content {
  justify-content: flex-end;
}
.check-btn[variant="IMAGE_ONLY"] {
  --height: 40px;
  --border-radius: 4px;
  --content-padding: 0;
}
.check-btn[variant="IMAGE_ONLY"] .check-btn__content {
  justify-content: center;
}
.check-btn[variant="IMAGE_ONLY"] .check-btn__img {
  max-width: 100%;
  max-height: calc(100% - 4px); /* border top & bottom */
  width: 100%;
  height: 100%;
}
.check-btn.img-error[variant="IMAGE_ONLY"] {
  --bg: transparent;
  --content-padding: 0 1rem;
}
.check-btn.img-error[variant="IMAGE_ONLY"] .check-btn__img,
.check-btn[variant="IMAGE_ONLY"] .check-btn__text {
  display: none;
}
.check-btn.img-error[variant="IMAGE_ONLY"] .check-btn__text {
  display: unset;
}
.check-btn__check {
  display: none;
  position: absolute;
  right: 1rem;
  top: 50%;
  transform: translateY(-50%);
  width: 0.75rem;
  height: 0.75rem;
  border-radius: 50%;
}
.check-btn__check svg {
  fill: var(--check-color);
}
.check-btn__content {
  position: relative;
  width: 100%;
  height: 100%;
  z-index: 1;
  display: flex;
  gap: 0.5rem;
  align-items: center;
  justify-content: flex-start;
  padding: var(--content-padding);
  background-color: var(--background5);
}
.check-btn__img {
  max-width: 32px;
  max-height: 32px;
}
.check-btn__img img {
  width: 100%;
  height: 100%;
  object-fit: contain;
}
.check-btn__text {
  display: inline-block;
  padding: 0.5rem 0;
  font-family: "Roboto";
  font-style: normal;
  font-weight: 500;
  font-size: var(--font-size);
  line-height: 16px;
  text-transform: capitalize;
  color: var(--text-color);
  word-break: break-word;
}
.check-btn::before {
  content: "";
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  border: 2px solid var(--border-color);
  border-radius: var(--border-radius);
  z-index: 2;
}

.selected .check-btn::before {
  border-color: var(--selected-border-color);
  z-index: 2;
}
.selected .check-btn .check-btn__text {
  color: var(--selected-text-color);
}
.check-btn .check-btn__text,
.check-btn::before {
  opacity: 0.5;
}
.selected .check-btn :deep(.check-btn__text),
.selected .check-btn::before {
  opacity: 1;
}

.selected .check-btn .check-btn__check {
  display: block;
  z-index: 2;
}
[layout="peru"] {
  @media (max-width: 639px) {
    .check-btn__img {
      display: none;
    }
    .menu-header .selected .check-btn .check-btn__check {
      display: none;
    }
    .check-btn__content {
      position: relative;
      width: 100%;
      height: 100%;
      z-index: 1;
      display: flex;
      gap: 0.5rem;
      align-items: center;
      justify-content: center;
      padding: var(--content-padding);
    }
  }
}
</style>
